unit logcont;

{ TODO : - Barry:
 - LogCont minimize
 - Stop logging at sunrise
 - plot last 24hrs or last 1hr window on same view.
 - FTP transfer
}

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics,
  Dialogs, StrUtils, dateutils,
  lazutf8sysutils, //Defines NOWUTC.
  SynMemo, TAGraph, TASeries, TAIntervalSources,
  fileview, //For opening log files.
  dlheader, //For Timezone conversions.
  appsettings, //For saving and restoring hotkeys.
  LCLType, // For kirtual key definitions used for hotkeys.
  Math, //for float identifier
  StdCtrls, ExtCtrls, Buttons, Grids, Spin, ComCtrls, PairSplitter,
  header_utils,
  moon, //required for Moon calculations
  //rotstageunit, //Rotational stage form
  synaser, synautil, blcksock
  , TACustomSeries, TARadialSeries
  //, TAStyles
  , TATools; //TBlockSerial for Rotational stage

type

  { TFormLogCont }

  TFormLogCont = class(TForm)
    ADAFactor: TLabeledEdit;
    ADASheet: TTabSheet;
    AltAzPlotpanel: TPanel;
    AnnotateButton: TButton;
    AnnotateEdit: TEdit;
    AnnotationGroupBox: TGroupBox;
    AnnotationSheet: TTabSheet;
    checkSRStart: TCheckBox;
    checkMTAStop: TCheckBox;
    checkMTNStop: TCheckBox;
    checkMTCStop: TCheckBox;
    checkETCStop: TCheckBox;
    checkETNStop: TCheckBox;
    checkETAStop: TCheckBox;
    checkSSStop: TCheckBox;
    checkMTAStart: TCheckBox;
    checkMTNStart: TCheckBox;
    checkMTCStart: TCheckBox;
    checkETCStart: TCheckBox;
    checkETNStart: TCheckBox;
    checkETAStart: TCheckBox;
    checkSSStart: TCheckBox;
    checkSRStop: TCheckBox;
    CloseButton: TBitBtn;
    CurrentTime: TStaticText;
    FilesLogged: TStaticText;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label4: TLabel;
    Labelfile: TLabel;
    LabelIn: TLabel;
    Labelinfile: TLabel;
    LatitudeLabel: TLabel;
    LatitudeText: TStaticText;
    LocationGroupBox: TGroupBox;
    LogfileNameLabel: TLabel;
    LogFileNameText: TEdit;
    LongitudeLabel: TLabel;
    LongitudeText: TStaticText;
    BottomPanel: TPanel;
    NextRecordAt: TStaticText;
    NextRecordAtLabel: TLabel;
    NextRecordIn: TStaticText;
    OpenFileButton: TBitBtn;
    PauseButton: TBitBtn;
    RecordsLogged: TStaticText;
    RecordsloggedLabel: TLabel;
    RecordsMissed: TStaticText;
    RecordsMissedLabel: TLabel;
    RecordsViewLabel: TLabel;
    RecordsViewSynMemo: TSynMemo;
    StartButton: TBitBtn;
    StartStopMemo: TMemo;
    SetLocationButton: TBitBtn;
    StopButton: TBitBtn;
    TimeSR: TLabel;
    TimeMTA: TLabel;
    TimeMTN: TLabel;
    TimeMTC: TLabel;
    TimeETC: TLabel;
    TimeETN: TLabel;
    TimeETA: TLabel;
    TimeSS: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    checkNowStart: TCheckBox;
    StartLabel: TLabel;
    StopLabel: TLabel;
    checkNeverStop: TCheckBox;
    StartStopGroup: TGroupBox;
    Chart1: TChart;
    Chart2: TChart;
    Chart2LineSeries1: TLineSeries;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    Displayedcdm2: TLabel;
    DisplayedNELM: TLabel;
    DisplayedNSU: TLabel;
    DisplayedReading: TLabel;
    EastLabel: TLabel;
    EditHotkeysCheckBox: TCheckBox;
    FineTimer: TTimer;
    GDMF0Button: TButton;
    GDMF1Button: TButton;
    GDMGroupBox: TGroupBox;
    GDMSheet: TTabSheet;
    GroupBox1: TGroupBox;
    HotkeyStringGrid: TStringGrid;
    Label49: TLabel;
    LCTrigMinutes: TSpinEdit;
    LCTrigSeconds: TSpinEdit;
    MinutesLabel: TLabel;
    MPSASSeries: TLineSeries;
    NorthLabel: TLabel;
    OpenLogDialog: TOpenDialog;
    PageControl1: TPageControl;
    PairSplitter1: TPairSplitter;
    PairSplitterTop: TPairSplitterSide;
    PairSplitterBottom: TPairSplitterSide;
    PendingHotKey: TEdit;
    PendingLabel: TLabel;
    PersistentCheckBox: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    ReadingSheet: TTabSheet;
    ReadingUnits: TLabel;
    RecordsViewMemo: TSynMemo;
    RotStageSheet: TTabSheet;
    RSComboBox: TComboBox;
    RSCurrentPositionAngleDisplay: TEdit;
    RSCurrentPositionStepDisplay: TEdit;
    RSDirInd: TStaticText;
    RSGroupBox: TGroupBox;
    RSLLimInd: TStaticText;
    RSMaxSteps: TLabeledEdit;
    RSPositionStepSpinEdit: TSpinEdit;
    RSRlimInd: TStaticText;
    RSSafteyInd: TStaticText;
    RSStatusBar: TStatusBar;
    SecondsLabel: TLabel;
    SouthLabel: TLabel;
    StartUpTimer: TTimer;
    SynchronizedCheckBox: TCheckBox;
    TriggerSheet: TTabSheet;
    WestLabel: TLabel;
    procedure AnnotateButtonClick(Sender: TObject);
    procedure checkMTAStartClick(Sender: TObject);
    procedure checkMTAStopClick(Sender: TObject);
    procedure checkNeverStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GDMF0ButtonClick(Sender: TObject);
    procedure GDMF1ButtonClick(Sender: TObject);
    procedure LCTrigMinutesChange(Sender: TObject);
    procedure LCTrigSecondsChange(Sender: TObject);
    procedure checkNowStartClick(Sender: TObject);
    //procedure AnnotateEditKeyPress(Sender: TObject; var Key: char);
    procedure OpenFileButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure EditHotkeysCheckBoxChange(Sender: TObject);
    procedure FineTimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure PersistentCheckBoxChange(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure SetLocationButtonClick(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure StartUpTimerTimer(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure HotkeyStringGridKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure HotkeyStringGridSelectEditor(Sender: TObject; aCol, aRow: integer;
      var Editor: TWinControl);
    procedure SynchronizedCheckBoxChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure CustomizeEdit(ACol, ARow: integer; Editor: TStringCellEditor);
    procedure CheckSynchronized();
  end;

var
  FormLogCont: TFormLogCont;
  LogTimePreset, LogTimeCurrent: integer;
  LCLoggedCount: integer; // Number of logged records taken during this session
  LCLogFileCount: integer; //Number of logfiles created during this session
  LCTriggerMode: integer; // radio button selection (0 - __)
  DesiredLogTime: TDateTime;
  StopRecording: boolean;
  Setting: string; //Setting of recorder
  Recording: boolean; //Flag to indicate that record is being logged
  RecordingMode: boolean = False; //Indicate that user has pressed Record button
  TimerBusy: boolean = False; //Flag to indicate that Timer event is being handled

  subfix: ansistring; //Used for time zone conversions

  //Command line automatic variables
  JustStarted:Boolean=True;

  //Used for logging and display
  Temperature, Darkness: Float;

  //Used to check 24 hr log file rollover
  LCStartFileTime: TDateTime;

  RecordsMissedCount: integer;
  //Determined while recording records, incrememts if meter does not respond.

  OldSecond: word; //Previous second value used to check timer rollover.

  AnnotateText: string;
  HotKeyCodes: array[1..100] of word;

  //Rotational stage variables
  RSResult: string; //The response string from the rotarduino
  RSpieces: TStringList; //Parts of the response string from the rotarduino
  RSCurrentAngle: Float; //determined from step signal fed back from rotarduino
  RSCurrentStepNumber: Integer = 0; //Counts the number of steps made
  RSCycle: integer = 0; //0=step left from 0deg, 1 = step right from 0deg

implementation

uses
  Unit1
  ,convertlogfileunit //Required for MyLatitude, MyLongitude, MyElevation variables
  ,Vector //VectorTab model
  , worldmap
 ;

var
    Altitude:Double;
    ValidStartStop: Boolean;

procedure UpdateStartStopText();
var
    s: String;
begin

  s:=''; //clear string

  //check start stop checkboxes and create a readable text string to describe the action(s).
  with FormLogCont do begin
    StartStopMemo.Clear;
    s:='Start logging:' + sLineBreak;
    //Append('Start logging immediately, and never stop.');
    if checkNowStart.Checked then  s:=s+' immediately' + sLineBreak;
    if checkMTAStart.Checked then  s:=s+' at astronomical morning twilight ' + sLineBreak;
    if checkMTNStart.Checked then  s:=s+' at nautical morning twilight ' + sLineBreak;
    if checkMTCStart.Checked then  s:=s+' at civil morning twilight ' + sLineBreak;
    if checkSRStart.Checked then  s:=s+' at sunrise ' + sLineBreak;
    if checkSSStart.Checked then  s:=s+' at sunset ' + sLineBreak;
    if checkETCStart.Checked then  s:=s+' at civil evening twilight ' + sLineBreak;
    if checkETNStart.Checked then  s:=s+' at nautical evening twilight ' + sLineBreak;
    if checkETAStart.Checked then  s:=s+' at astronmical evening twilight ' + sLineBreak;

    s:=s+sLineBreak+'and stop logging:' + sLineBreak;
    if checkMTAStop.Checked then  s:=s+' at astronomical morning twilight ' + sLineBreak;
    if checkMTNStop.Checked then  s:=s+' at nautical morning twilight ' + sLineBreak;
    if checkMTCStop.Checked then  s:=s+' at civil morning twilight ' + sLineBreak;
    if checkSRStop.Checked then  s:=s+' at sunrise ' + sLineBreak;
    if checkSSStop.Checked then  s:=s+' at sunset ' + sLineBreak;
    if checkETCStop.Checked then  s:=s+' at civil evening twilight ' + sLineBreak;
    if checkETNStop.Checked then  s:=s+' at nautical evening twilight ' + sLineBreak;
    if checkETAStop.Checked then  s:=s+' at astronmical evening twilight ' + sLineBreak;
    if checkNeverStop.Checked then  s:=s+' never' + sLineBreak;

    StartStopMemo.Append(s);
  end;
end;

procedure CheckStartStopValidity();
var
  Balance: Integer;
  StartStopSame: Boolean;
  LocationMissing: Boolean;
begin
  Balance:=0;
  StartStopSame:=False;
  LocationMissing:=False;

  with FormLogCont do begin
    //Check number of selected Starts compared to number of selected Stops
    if checkNowStart.Checked then inc(Balance);
    if checkMTAStart.Checked then inc(Balance);
    if checkMTNStart.Checked then inc(Balance);
    if checkMTCStart.Checked then inc(Balance);
    if checkSRStart.Checked then inc(Balance);
    if checkSSStart.Checked then inc(Balance);
    if checkETCStart.Checked then inc(Balance);
    if checkETNStart.Checked then inc(Balance);
    if checkETAStart.Checked then inc(Balance);

    if checkMTAStop.Checked then dec(Balance);
    if checkMTNStop.Checked then dec(Balance);
    if checkMTCStop.Checked then dec(Balance);
    if checkSRStop.Checked then dec(Balance);
    if checkSSStop.Checked then dec(Balance);
    if checkETCStop.Checked then dec(Balance);
    if checkETNStop.Checked then dec(Balance);
    if checkETAStop.Checked then dec(Balance);
    if checkNeverStop.Checked then dec(Balance);

    //Check that Start is not the same as Stop
    StartStopSame:=
      (checkMTAStart.Checked and checkMTAStop.Checked) or
      (checkMTNStart.Checked and checkMTNStop.Checked) or
      (checkMTCStart.Checked and checkMTCStop.Checked) or
      (checkSRStart.Checked  and checkSRStop.Checked ) or
      (checkSSStart.Checked  and checkSSStop.Checked ) or
      (checkETCStart.Checked and checkETCStop.Checked) or
      (checkETNStart.Checked and checkETNStop.Checked) or
      (checkETAStart.Checked and checkETAStop.Checked);


    //Check for valid location
    if ((StrToFloatDef(LatitudeText.Caption,0)=0) or (StrToFloatDef(LongitudeText.Caption,0) = 0)) then LocationMissing:=True;

    // Prepare memo for possible error messages
    StartStopMemo.Clear;

    //Show warnings
    if Balance <> 0 then StartStopMemo.Append('Number of starts ≠ stops.');
    if StartStopSame then StartStopMemo.Append('Start and stop time must be different.');
    if LocationMissing then StartStopMemo.Append('Latitude and/or Longitude not set.');

    //Set global valid flag
    ValidStartStop:=not ((Balance <> 0) or StartStopSame or LocationMissing);

    //Update textual desription if valid
    if ValidStartStop then UpdateStartStopText();

  end;

end;

procedure SaveStartStopSettings();
begin

  CheckStartStopValidity();

  if ValidStartStop then begin
    with FormLogCont do begin
      vConfigurations.WriteBool('LogContinuousSettings', 'StartNow', checkNowStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartMTA', checkMTAStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartMTN', checkMTNStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartMTC', checkMTCStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartSR', checkSRStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartSS', checkSSStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartETC', checkETCStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartETN', checkETNStart.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StartETA', checkETAStart.Checked);

      vConfigurations.WriteBool('LogContinuousSettings', 'StopMTA', checkMTAStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopMTN', checkMTNStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopMTC', checkMTCStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopSR', checkSRStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopSS', checkSSStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopETC', checkETCStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopETN', checkETNStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopETA', checkETAStop.Checked);
      vConfigurations.WriteBool('LogContinuousSettings', 'StopNever', checkNeverStop.Checked);
    end;
  end;

end;

procedure UpdateAstroTimes();
begin

  with FormLogCont do
  begin
    TimeMTC.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Morning_Twilight_Civil(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));

    TimeETC.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Evening_Twilight_Civil(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));

    TimeMTN.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Morning_Twilight_Nautical(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));

    TimeETN.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Evening_Twilight_Nautical(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));

    TimeMTA.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Morning_Twilight_Astronomical(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));

    TimeETA.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Evening_Twilight_Astronomical(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));

    TimeSR.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Sun_Rise(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));

    TimeSS.Caption:=  FormatDateTime('tt',
      dlheader.ptz.GMTToLocalTime(Sun_Set(NowUTC, MyLatitude, -1.0*MyLongitude),DLHeaderForm.TZLocationBox.Text, subfix));
  end;

end;

procedure GetStartStopSettings();
var
  NumStart, NumStop: Integer;

begin

  with FormLogCont do begin
    checkNowStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartNow', False);
    checkMTAStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartMTA', False);
    checkMTNStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartMTN', False);
    checkMTCStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartMTC', False);
    checkSRStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartSR', False);
    checkSSStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartSS', False);
    checkETCStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartETC', False);
    checkETNStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartETN', False);
    checkETAStart.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StartETA', False);

    checkMTAStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopMTA', False);
    checkMTNStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopMTN', False);
    checkMTCStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopMTC', False);
    checkSRStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopSR', False);
    checkSSStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopSS', False);
    checkETCStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopETC', False);
    checkETNStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopETN', False);
    checkETAStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopETA', False);
    checkNeverStop.Checked:=vConfigurations.ReadBool('LogContinuousSettings', 'StopNever', False);

    //Get location
    LatitudeText.Caption := Format('%0.6f',[MyLatitude]);
    LongitudeText.Caption:= Format('%0.6f',[MyLongitude]);

    //Check validity
    //ensure at least one Start
    NumStart:=0;
    if checkMTAStart.Checked then inc(NumStart);
    if checkMTNStart.Checked then inc(NumStart);
    if checkMTCStart.Checked then inc(NumStart);
    if checkSRStart.Checked then inc(NumStart);
    if checkSSStart.Checked then inc(NumStart);
    if checkETCStart.Checked then inc(NumStart);
    if checkETNStart.Checked then inc(NumStart);
    if checkETAStart.Checked then inc(NumStart);
    if NumStart=0 then checkNowStart.Checked:=True;

    //ensure at least one Stop
    NumStop:=0;
    if checkMTAStop.Checked then inc(NumStop);
    if checkMTNStop.Checked then inc(NumStop);
    if checkMTCStop.Checked then inc(NumStop);
    if checkSRStop.Checked then inc(NumStop);
    if checkSSStop.Checked then inc(NumStop);
    if checkETCStop.Checked then inc(NumStop);
    if checkETNStop.Checked then inc(NumStop);
    if checkETAStop.Checked then inc(NumStop);
    if NumStop=0 then checkNeverStop.Checked:=True;
  end;

  if ((NumStart>0) or (NumStop>0)) then
    SaveStartStopSettings()
  else
    CheckStartStopValidity();

    UpdateAstroTimes();

end;

function MPSASToRGB(MPSAS: Double): Tcolor;
//Convert MPSAS to Tcolor RGB value
// using plot from Dan Duriscoe ADA463050.pdf
var
    R: Integer = 0;
    G: Integer = 0;
    B: Integer = 0;

const
   White = 18.0;// (RGB)
     Red = 18.7;// (R  )
  Yellow = 20.0;// (RG )
   Green = 20.4;// ( G )
    Blue = 21.1;// (  B)
   Black = 22.5;// (   )

procedure MinMaxRange(InX, StartX, StopX, StartY, StopY: Double; var OutY: Integer);
var
     m,b: Double; //Slope, Offset
begin
  if ((InX>StartX) and (InX<=StopX)) then begin
    m:=(StopY - StartY) / (StopX - StartX);
    b:=StartY - M * StartX;
    OutY:= round((m * InX + b) * 255);
  end;
end;

begin
  MinMaxRange(MPSAS,0,Yellow,1,1,R);
  MinMaxRange(MPSAS,Yellow,Green,1,0,R);
  MinMaxRange(MPSAS,Green,Blue,0,0,R);
  MinMaxRange(MPSAS,Blue,Blue+(Black-Blue)/2,0,1,R);
  MinMaxRange(MPSAS,Blue+(Black-Blue)/2,Black,1,0,R);

  MinMaxRange(MPSAS,0,White,1,1,G);
  MinMaxRange(MPSAS,White,Red,1,0,G);
  MinMaxRange(MPSAS,Red,Yellow,0,1,G);
  MinMaxRange(MPSAS,Yellow,Green,1,1,G);
  MinMaxRange(MPSAS,Green,Blue,1,0,G);
  MinMaxRange(MPSAS,Blue,100,0,0,G);

  MinMaxRange(MPSAS,0,White,1,1,B);
  MinMaxRange(MPSAS,White,Red,1,0,B);
  MinMaxRange(MPSAS,Red,Green,0,0,B);
  MinMaxRange(MPSAS,Green,Blue,0,1,B);
  MinMaxRange(MPSAS,Blue,Black,1,0,B);
  MinMaxRange(MPSAS,Black,100,0,0,B);

  MPSASToRGB:= RGBToColor(R, G, B);
end;

procedure ParseRotstage(Result:String);
begin
  RSpieces.DelimitedText := Result;

  //0 current position
  RSCurrentAngle := StrToFloatDef(RSpieces.Strings[0], 0.0) * 90.0 / 50.0;

  //1 Right limit value, 1=hit
  if (RSpieces.Strings[1]='1') then FormLogCont.RSRlimInd.Color:=clRed else FormLogCont.RSRlimInd.Color:=clDefault;

  //2 Left limit value, 1=hit
  if (RSpieces.Strings[2]='1') then FormLogCont.RSLlimInd.Color:=clRed else FormLogCont.RSLlimInd.Color:=clDefault;

  //3 Safety limit value
  if (RSpieces.Strings[3]='1') then FormLogCont.RSSafteyInd.Color:=clRed else FormLogCont.RSSafteyInd.Color:=clDefault;

  //4 Reset value 0 = reset
  //  Writeln(RSpieces.Strings[4]);

  //5 desired Step direction  0=left, 1=right
  if (RSpieces.Strings[5]='1') then FormLogCont.RSDirInd.Caption:='Dir=Right' else FormLogCont.RSDirInd.Caption:='Dir=Left';

  //6 actual step direction
  //7 Sleep value 0 = sleep

  FormLogCont.RSCurrentPositionAngleDisplay.Text := Format('%1.1f', [RSCurrentAngle]);

end;

function keyslist(Key: word): string;
type
  TSendKey = record
    Name: ShortString;
    VKey: byte;
  end;
const
  {Array of keys that SendKeys recognizes.

  If you add to this list, you must be sure to keep it sorted alphabetically
  by Name because a binary search routine is used to scan it.

  http://delphiworld.narod.ru/base/sendkeys_vb.html}

  MaxSendKeyRecs = 77;
  SendKeyRecs: array[1..MaxSendKeyRecs] of TSendKey =
    (
    (Name: 'F1'; VKey: VK_F1),
    (Name: 'F2'; VKey: VK_F2),
    (Name: 'F3'; VKey: VK_F3),
    (Name: 'F4'; VKey: VK_F4),
    (Name: 'F5'; VKey: VK_F5),
    (Name: 'F6'; VKey: VK_F6),
    (Name: 'F7'; VKey: VK_F7),
    (Name: 'F8'; VKey: VK_F8),
    (Name: 'F9'; VKey: VK_F9),
    (Name: 'F10'; VKey: VK_F10),
    (Name: 'F11'; VKey: VK_F11),
    (Name: 'F12'; VKey: VK_F12),
    (Name: 'F13'; VKey: VK_F13),
    (Name: 'F14'; VKey: VK_F14),
    (Name: 'F15'; VKey: VK_F15),
    (Name: 'F16'; VKey: VK_F16),
    (Name: 'F17'; VKey: VK_F17),
    (Name: 'F18'; VKey: VK_F18),
    (Name: 'F19'; VKey: VK_F19),
    (Name: 'F20'; VKey: VK_F20),
    (Name: 'F21'; VKey: VK_F21),
    (Name: 'F22'; VKey: VK_F22),
    (Name: 'F23'; VKey: VK_F23),
    (Name: 'F24'; VKey: VK_F24),
    (Name: '0'; VKey: VK_0),
    (Name: '1'; VKey: VK_1),
    (Name: '2'; VKey: VK_2),
    (Name: '3'; VKey: VK_3),
    (Name: '4'; VKey: VK_4),
    (Name: '5'; VKey: VK_5),
    (Name: '6'; VKey: VK_6),
    (Name: '7'; VKey: VK_7),
    (Name: '8'; VKey: VK_8),
    (Name: '9'; VKey: VK_9),
    (Name: 'A'; VKey: VK_A),
    (Name: 'B'; VKey: VK_B),
    (Name: 'C'; VKey: VK_C),
    (Name: 'D'; VKey: VK_D),
    (Name: 'E'; VKey: VK_E),
    (Name: 'F'; VKey: VK_F),
    (Name: 'G'; VKey: VK_G),
    (Name: 'H'; VKey: VK_H),
    (Name: 'I'; VKey: VK_I),
    (Name: 'J'; VKey: VK_J),
    (Name: 'K'; VKey: VK_K),
    (Name: 'L'; VKey: VK_L),
    (Name: 'M'; VKey: VK_M),
    (Name: 'N'; VKey: VK_N),
    (Name: 'O'; VKey: VK_O),
    (Name: 'P'; VKey: VK_P),
    (Name: 'Q'; VKey: VK_Q),
    (Name: 'R'; VKey: VK_R),
    (Name: 'S'; VKey: VK_S),
    (Name: 'T'; VKey: VK_T),
    (Name: 'U'; VKey: VK_U),
    (Name: 'V'; VKey: VK_V),
    (Name: 'W'; VKey: VK_W),
    (Name: 'X'; VKey: VK_X),
    (Name: 'Y'; VKey: VK_Y),
    (Name: 'Z'; VKey: VK_Z),
    (Name: 'SPACE'; VKey: VK_SPACE),
    (Name: 'NUMPAD0'; VKey: VK_NUMPAD0),
    (Name: 'NUMPAD1'; VKey: VK_NUMPAD1),
    (Name: 'NUMPAD2'; VKey: VK_NUMPAD2),
    (Name: 'NUMPAD3'; VKey: VK_NUMPAD3),
    (Name: 'NUMPAD4'; VKey: VK_NUMPAD4),
    (Name: 'NUMPAD5'; VKey: VK_NUMPAD5),
    (Name: 'NUMPAD6'; VKey: VK_NUMPAD6),
    (Name: 'NUMPAD7'; VKey: VK_NUMPAD7),
    (Name: 'NUMPAD8'; VKey: VK_NUMPAD8),
    (Name: 'NUMPAD9'; VKey: VK_NUMPAD9),
    (Name: 'MULTIPLY'; VKey: VK_MULTIPLY),
    (Name: 'ADD'; VKey: VK_ADD),
    (Name: 'SEPARATOR'; VKey: VK_SEPARATOR),
    (Name: 'SUBTRACT'; VKey: VK_SUBTRACT),
    (Name: 'DECIMAL'; VKey: VK_DECIMAL),
    (Name: 'DIVIDE'; VKey: VK_DIVIDE)
    );

var
  A: TSendKey;

begin
  keyslist := '';
  for A in SendKeyRecs do
  begin
    if Key = A.VKey then
      keyslist := A.Name;
  end;

end;



function Sec2DHMS(InSeconds: integer): string;
var
  Days: integer;
  Hours: integer;
  InHours: integer;
  Minutes: integer;
  InMinutes: integer;
  Seconds: integer;
begin
  Seconds := InSeconds mod 60;
  InMinutes := InSeconds div 60;

  Minutes := InMinutes mod 60;
  InHours := InMinutes div 60;

  Hours := InHours mod 24;
  Days := InHours div 24;

  Sec2DHMS := Format('%.1dd %.2d:%.2d:%.2d', [Days, Hours, Minutes, Seconds]);
end;

procedure OnTheClock(const ThisMoment: TDateTime; const Granularity: integer);
{This utility gets the next time from now based on a granularity setting,
 i.e for determining log time and difference for logging every x minutes}
begin
  // Determine new record time and calculate time until record
  DesiredLogTime := ThisMoment; //Copy current time for manipulation
  DesiredLogTime := IncMinute(DesiredLogTime, Granularity -
    MinuteOf(ThisMoment) mod Granularity);
  //Replace seconds with 0
  DesiredLogTime := RecodeSecond(DesiredLogTime, 0);
  FormLogCont.NextRecordAt.Caption :=
    FormatDateTime('yyyy-mm-dd hh:nn:ss', DesiredLogTime);
  LogTimeCurrent := SecondsBetween(ThisMoment, DesiredLogTime);
end;

procedure LogOneReading();
var
  pieces: TStringList; //delimited result from generic read
  Result: string;
  ThisMoment, ThisMomentUTC: TDateTime;

  function CheckRedordCount(): boolean;
  begin
    if ((SelectedModel = model_ADA) and (pieces.Count = 8)) or //Model 1 = ADA
      ((SelectedModel = model_GDM) and (pieces.Count = 3)) or //Model 8 = GDM
      (((SelectedModel = model_LELU) or (SelectedModel = model_LR) or (SelectedModel = model_DL)) and (pieces.Count = 6)) or
      ((SelectedModel = model_V) and (pieces.Count = 6))  then //Model 11 vector
      CheckRedordCount := True
    else
    begin
      CheckRedordCount := False;
      StatusMessage(format( 'CheckRedordCount fail: SelectedModel = %d pieces.Count = %d',[SelectedModel,pieces.Count]));
    end;
  end;

  procedure WriteRecord(Special: string = '');
  var
    ComposeString: string;
    Reading1, Reading2: integer; //Mainly for ADA readings
  begin
    ThisMomentUTC := NowUTC;
    ThisMoment := dlheader.ptz.GMTToLocalTime(ThisMomentUTC,
      DLHeaderForm.TZLocationBox.Text, subfix);

    Application.ProcessMessages;

    //Create new logfile if over 24hr UTC time.
    if (DayOf(LCStartFileTime) <> DayOf(ThisMoment)) then
    begin
      // Open new file and store header
      WriteDLHeader('LE', Format('Logged continuously %s.', [setting]));

      LCStartFileTime := ThisMoment;

      // Display number of logfiles
      Inc(LCLogFileCount);
      FormLogCont.FilesLogged.Caption := IntToStr(LCLogFileCount);
      if LCLogFileCount = 1 then
        FormLogCont.Labelfile.Caption := 'file'
      else
        FormLogCont.Labelfile.Caption := 'files';
    end
    else
    begin
      AssignFile(DLRecFile, LogFileName);
      Append(DLRecFile); //Open file for appending
      SetTextLineEnding(DLRecFile, #13#10);
    end;

    // Display LogFileNameText path
    FormLogCont.LogFileNameText.Caption := LogFileName;

    if (Special = '') then
    begin
      if SelectedModel = model_ADA then //ADA device
      begin
        { Pull in values }
        Reading1 := StrToIntDef(AnsiMidStr(pieces.Strings[2], 1, 10), 0);
        Reading2 := StrToIntDef(AnsiMidStr(pieces.Strings[4], 1, 10), 0);

        // YYYY-MM-DDTHH:mm:ss.fff;YYYY-MM-DDTHH:mm:ss.fff;Hz;Count1;Time1;Count2;Time2
        { TODO : make header description for ADA match data }
        //r,0000000238Hz,0000000000c,0000000.000s,0000000000c,0000000.000s,000,109
        ComposeString :=
          FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', NowUTC) //Date UTC
          + FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', Now) //Date Local
          + Format('%d;', [StrToIntDef(AnsiMidStr(pieces.Strings[1], 1, 10), 0)])
          //Frequency
          + Format('%d;', [Reading1]) //Counter1
          + Format('%1.3f;', [StrToFloatDef(AnsiMidStr(pieces.Strings[3], 1, 11),
          0)]) //Time1
          + Format('%d;', [Reading2]) //Counter2
          + Format('%1.3f;', [StrToFloatDef(AnsiMidStr(pieces.Strings[5], 1, 11), 0)])
        //Time2
        ;
        // Update analog sensor display
        FormLogCont.ADAFactor.Visible := True;
        if Reading2 <> 0 then
          FormLogCont.ADAFactor.Caption := Format('%1.3f', [Reading1 / Reading2])
        else
          FormLogCont.ADAFactor.Caption := '0';
      end  //End of ADA device

      else if SelectedModel = model_GDM then //GDM device
      begin
        { Pull in values }
        Reading1 := StrToIntDef(AnsiMidStr(pieces.Strings[1], 1, 10), 0);

        if StrToIntDef(pieces.Strings[2],0) < 4096 then
           Temperature:=StrToFloatDef(pieces.Strings[2],0,FPointSeparator)/128.0
        else
           Temperature:=(StrToFloatDef(pieces.Strings[2],0,FPointSeparator)-65536.0)/128.0;

        // YYYY-MM-DDTHH:mm:ss.fff;YYYY-MM-DDTHH:mm:ss.fff;Count;Temp
        //r,0000000000c,xxxx
        ComposeString :=
          FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', NowUTC)//Date UTC
          + FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', Now)//Date Local
          + Format('%d;', [Reading1])//Counter
          + Format('%1.3f;', [Temperature])//Temperature
        ;
      end  //End of GDM device

      else //must be LE or LU device
      begin

        { Pull in values }
        Temperature := StrToFloatDef(
          AnsiLeftStr(pieces.Strings[5], Length(pieces.Strings[5]) - 1), 0,
          FPointSeparator);
        Darkness := StrToFloatDef(AnsiLeftStr(pieces.Strings[1],
          Length(pieces.Strings[1]) - 1), 0, FPointSeparator);

        // YYYY-MM-DDTHH:mm:ss.fff;YYYY-MM-DDTHH:mm:ss.fff;Celsius;number;Hz;mag/arcsec^2')
        ComposeString :=
          FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', ThisMomentUTC) //Date UTC
          //+ FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', Now) //Date Local
          //+ FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', DesiredLogTime)
          + FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', ThisMoment)
          //Date Local (calculated)
          + FormatFloat('##0.0', Temperature, FPointSeparator) + ';' //Temperature
          + Format('%d;', [StrToIntDef(AnsiLeftStr(pieces.Strings[3],
          length(pieces.Strings[3]) - 1), 0)]) //counts
          + Format('%d;', [StrToIntDef(AnsiLeftStr(pieces.Strings[2],
          length(pieces.Strings[2]) - 2), 0)]) //Hz
          + FormatFloat('#0.00', Darkness, FPointSeparator) //mpsas value
        ;
        if SelectedModel = model_V then //Vector device
        begin
          GetAccel();
          GetMag(False);
          NormalizeAccel(); //Compute acceleration values (In the future, this may be done inside the PIC)
          ComputeAzimuth();
          Altitude:=radtodeg(arcsin(-1.0*Ax1));
          Heading:=radtodeg(arctan2(-1*Mz2,Mx2))+180;
          ComposeString := ComposeString + Format(';%0.0f;%0.0f',[
             Altitude,    // Altitude
             Heading]);    // Azimuth
        end;
      end; //End of LE LU device

      //Check if Rotational stage angle infromation must be added to record
      if (rotstage) then
        ComposeString := ComposeString + ';' + FormLogCont.RSCurrentPositionAngleDisplay.Text;

      //Add possible annotation to end of record.
      if (Length(AnnotateText) > 0) then
      begin
        ComposeString := ComposeString + ';' + AnnotateText;
        if (not FormLogCont.PersistentCheckBox.Checked) then
        begin
          AnnotateText := '';
          FormLogCont.PendingHotKey.Text := '';
        end;
      end; //End of annotation.

    end //end of "special" text check when no data was available (missed record).
    else
    begin
      ComposeString :=
        FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', NowUTC) //Date UTC
        + FormatDateTime('yyyy-mm-dd"T"hh:nn:ss.zzz";"', Now) //Date Local
        + Special;
    end;

    //Update displayed readings
    FormLogCont.DisplayedReading.Caption := FormatFloat('#0.00', Darkness, FPointSeparator);
    FormLogCont.DisplayedNELM.Caption    := FormatFloat('#0.00', 7.93 - 5 * log10(power(10,(4.316-(Darkness/5)))+1), FPointSeparator)+' NELM';
    FormLogCont.Displayedcdm2.Caption    := FormatFloat('0.00E+2', 10.8e4 * power(10,(-0.4*Darkness)) , FPointSeparator)+' cdm2';
    FormLogCont.DisplayedNSU.Caption     := FormatFloat('#0.00', power(10,(0.4*(21.6-Darkness))), FPointSeparator)+' NSU';

    UpdateAstroTimes();

    //Update Chart
    FormLogCont.MPSASSeries.AddXY(Now,Darkness);

    if SelectedModel=model_V then begin
      //AltitudeSeries.AddXY(Now,Altitude);
      //AzimuthSeries.AddXY(Now,Heading);
      //Chart2PolarSeries1.AddXY(degtorad(Heading),1.0-Altitude/90.0);
       //Chart2LineSeries1.AddXY(cos(degtorad(Heading+90))*(1.0-abs(Altitude/90.0)),sin(degtorad(Heading+90))*(1.0-abs(Altitude/90.0)));
       FormLogCont.Chart2LineSeries1.Addxy(
         cos(degtorad(Heading+90))*(1.0-abs(Altitude/90.0)),
         sin(degtorad(Heading+90))*(1.0-abs(Altitude/90.0)),
         'x',
         MPSASToRGB(Darkness));
       //writeln(format('%6.2f %6.2f',[Heading, degtorad(Heading)]));
    end;

    Writeln(DLRecFile, ComposeString);
    FormLogCont.RecordsViewSynMemo.Append(ComposeString);
    //Ensure that latest append is displayed at bottom of window.
    FormLogCont.RecordsViewSynMemo.CaretY := FormLogCont.RecordsViewSynMemo.Lines.Count;
    Inc(LCLoggedCount);
    FormLogCont.RecordsLogged.Caption := IntToStr(LCLoggedCount);

    //Perform rotational stage operation if enabled
    if (rotstage) then
    begin
      //Sweep from one side to the other by x steps
      RSser.SendString('S' + IntToStr(FormLogCont.RSPositionStepSpinEdit.Value) +
        chr(13) + chr(10));

      //update step display
      Inc(RSCurrentStepNumber);
      FormLogCont.RSCurrentPositionStepDisplay.Text:=IntToStr(RSCurrentStepNumber);

      ParseRotstage(Trim(RSser.Recvstring(20000)));//update status display of rotational stage hardware

      if (StrToIntDef(FormLogCont.RSCurrentPositionStepDisplay.Text, 0) >=
        StrToIntDef(FormLogCont.RSMaxSteps.Text, 0)) then
        StopRecording := True;
      Application.ProcessMessages;
    end;

  end;

begin
  Recording := True;
  pieces := TStringList.Create;
  pieces.Delimiter := ',';
  pieces.StrictDelimiter := False; //Parse spaces also

  //Try a first time
  Result := GetReading;
  pieces.DelimitedText := Result;
  if CheckRedordCount then
    WriteRecord
  else
  begin //Try a second time
    Result := GetReading;
    pieces.DelimitedText := Result;
    if CheckRedordCount then
      WriteRecord
    else
    begin //Try a second time
      Result := GetReading;
      pieces.DelimitedText := Result;
      if CheckRedordCount then
        WriteRecord
      else
      begin
        Inc(RecordsMissedCount);
        WriteRecord(';;;'); //Empty fields
        FormLogCont.RecordsMissed.Color := clRed;
        FormLogCont.RecordsMissed.Font.Color := clWhite;
        FormLogCont.RecordsMissed.Caption := IntToStr(RecordsMissedCount);
      end;
    end;
  end;

  Flush(DLRecFile);
  Close(DLRecFile);
  Recording := False;
end;

{ TFormLogCont }

procedure TFormLogCont.OpenFileButtonClick(Sender: TObject);
begin
  OpenLogDialog.InitialDir := appsettings.LogsDirectory;
  if OpenLogDialog.Execute then
  begin
    Form2.Memo1.Lines.LoadFromFile(OpenLogDialog.Filename);
    Form2.Show;
  end;

end;

procedure TFormLogCont.AnnotateButtonClick(Sender: TObject);
begin
  //Initiate a recording with annotated text while already in record-mode.
  AnnotateText := FormLogCont.AnnotateEdit.Text;
  PendingHotKey.Text := AnnotateText;
  if (not SynchronizedCheckBox.Checked) then
    LogOneReading;
end;

procedure TFormLogCont.checkMTAStartClick(Sender: TObject);
begin
  //check if NowStart should be checked
  if checkMTAStart.Checked or
     checkMTNStart.Checked or
     checkMTCStart.Checked or
     checkSRStart.Checked or
     checkSSStart.Checked or
     checkETCStart.Checked or
     checkETNStart.Checked or
     checkETAStart.Checked then begin
       checkNowStart.Checked:=False;
  end else begin
       checkNowStart.Checked:=True;
  end;

  SaveStartStopSettings();
end;

procedure TFormLogCont.checkMTAStopClick(Sender: TObject);
begin
  //check if NeverStop should be checked
  if checkMTAStop.Checked or
     checkMTNStop.Checked or
     checkMTCStop.Checked or
     checkSRStop.Checked or
     checkSSStop.Checked or
     checkETCStop.Checked or
     checkETNStop.Checked or
     checkETAStop.Checked then begin
       checkNeverStop.Checked:=False;
  end else begin
       checkNeverStop.Checked:=True;
  end;

  SaveStartStopSettings();

end;

procedure TFormLogCont.checkNeverStopClick(Sender: TObject);
begin
  //Clear off other STOP checkboxes if checked
  if checkNeverStop.Checked then begin
    checkMTAStop.Checked:=False;
    checkMTNStop.Checked:=False;
    checkMTCStop.Checked:=False;
    checkSRStop.Checked:=False;
    checkSSStop.Checked:=False;
    checkETCStop.Checked:=False;
    checkETNStop.Checked:=False;
    checkETAStop.Checked:=False;
  end;
  SaveStartStopSettings(); //Save to ini file
end;


procedure TFormLogCont.FormCreate(Sender: TObject);
begin


  //if ((Length(DLHeaderForm.PositionEntry  TZRegionBox.Text)>0) and (Length(DLHeaderForm.TZLocationBox.Text)>0)) then
  //begin
  //end;


  //Get previous settings from configuration file
  LCTrigSeconds.Value:=LimitInteger(StrToIntDef(vConfigurations.ReadString('LogContinuousSettings', 'Seconds', '1'),1),1,255);
  LCTrigMinutes.Value:=LimitInteger(StrToIntDef(vConfigurations.ReadString('LogContinuousSettings', 'Minutes', '1'),1),1,255);

  //See commandlineoptions.txt for more details (overrides configuration settings)
  //Check for and mode setting
  if (ParameterCommand('-LCM') or ParameterCommand('-LCMS') or ParameterCommand('-LCMM')) then begin
    if ((ParameterCommand('-LCM')) and (ParameterValue.Count>1)) then  //Set mode from command line
        case StrToIntDef(ParameterValue.Strings[1],0) of
          1:LCTriggerMode:=2;//Every 1 minute on the minute
          5:LCTriggerMode:=3;//Every 5 minutes on the 1/12th hour
          10:LCTriggerMode:=4;//Every 10 minutes on the 1/6th hour
          15:LCTriggerMode:=5;//Every 15 minutes on the 1/4 hour
          30:LCTriggerMode:=6;//Every 30 minutes on the 1/2 hour
          60:LCTriggerMode:=7;//Every hour on the hour
        end;
    if ((ParameterCommand('-LCMS')) and (ParameterValue.Count>1)) then  //Set seconds value from command line
      begin
        LCTrigSeconds.Value:=StrToIntDef(ParameterValue.Strings[1],0);
        LCTriggerMode:=0;//Every x seconds
      end;
    if ((ParameterCommand('-LCMM')) and (ParameterValue.Count>1)) then  //Set minutes value from command line
      begin
        LCTrigMinutes.Value:=StrToIntDef(ParameterValue.Strings[1],0);
        LCTriggerMode:=1;  //Every x minutes
      end;

  end
  else begin
    //read mode from stored configuration file data
    LCTriggerMode:=StrToIntDef(vConfigurations.ReadString('LogContinuousSettings', 'Mode', '2'),2);
  end;

  // Set trigger mode accordingly from above determinations
  case LCTriggerMode of
    0:RadioButton1.Checked:=True;
    1:RadioButton2.Checked:=True;
    2:RadioButton3.Checked:=True;
    3:RadioButton4.Checked:=True;
    4:RadioButton5.Checked:=True;
    5:RadioButton6.Checked:=True;
    6:RadioButton7.Checked:=True;
    7:RadioButton8.Checked:=True;
  end;

  //Initialize Rotational stage variables and display
  RSpieces := TStringList.Create;
  RSpieces.Delimiter := ',';
  RSpieces.StrictDelimiter := True; //Do not parse spaces
  if ((Paramcount > 0) and (ParamStr(1) = 'rotstage')) then begin
    rotstage := True;
  end;

end;

procedure TFormLogCont.GDMF0ButtonClick(Sender: TObject);
begin
      SendGet('f0x') //clear feedback coil current
end;

procedure TFormLogCont.GDMF1ButtonClick(Sender: TObject);
begin
    SendGet('f1x') //clear feedback coil current
end;

procedure TFormLogCont.LCTrigMinutesChange(Sender: TObject);
begin
  //Save to configuration file
  vConfigurations.WriteString('LogContinuousSettings', 'Minutes',LCTrigMinutes.Text);
end;

procedure TFormLogCont.LCTrigSecondsChange(Sender: TObject);
begin
  //Save to configuration file
  vConfigurations.WriteString('LogContinuousSettings', 'Seconds',LCTrigSeconds.Text);
end;

procedure TFormLogCont.checkNowStartClick(Sender: TObject);
begin
  //Clear off other START checkboxes if checked
  if checkNowStart.Checked then begin
    checkMTAStart.Checked:=False;
    checkMTNStart.Checked:=False;
    checkMTCStart.Checked:=False;
    checkSRStart.Checked:=False;
    checkSSStart.Checked:=False;
    checkETCStart.Checked:=False;
    checkETNStart.Checked:=False;
    checkETAStart.Checked:=False;
  end;

  SaveStartStopSettings(); //Save to ini file
end;

//procedure TFormLogCont.AnnotateEditKeyPress(Sender: TObject; var Key: char);
//begin
//  // Only annotate if recording.
//  // Annotate when the enter key (#13) is pressed.
//  if ((RecordingMode) and (Key = #13)) then
//    AnnotateButtonClick(Sender);
//end;

procedure TFormLogCont.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TFormLogCont.EditHotkeysCheckBoxChange(Sender: TObject);
begin
  if EditHotkeysCheckBox.Checked then
  begin
    HotkeyStringGrid.Enabled := True;
    HotkeyStringGrid.Font.Color := clDefault;
  end
  else
  begin
    HotkeyStringGrid.Enabled := False;
    HotkeyStringGrid.Font.Color := clInactiveCaption;
  end;

end;

procedure TFormLogCont.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  if CloseButton.Enabled then
    Close
  else
    StopRecording := True;

end;

procedure TFormLogCont.FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
var
  i: integer;

begin
  if RecordingMode and not (AnnotateEdit.Focused or EditHotkeysCheckBox.Checked) then
  begin
    //Search for key in hotkey list
    //writeln(char(key),' = ',Key);
    keyslist(Key);
    for i := 1 to HotkeyStringGrid.RowCount - 1 do
    begin
      if (Key = HotKeyCodes[i]) then
      begin
        AnnotateText := vConfigurations.ReadString('HotKeys', 'a' +
          IntToStr(i - 1), '');
        PendingHotKey.Text := AnnotateText;
        if (not SynchronizedCheckBox.Checked) then
          LogOneReading
        else
          PendingHotKey.Text := AnnotateText;
      end;
    end;
  end;
end;

procedure TFormLogCont.FormShow(Sender: TObject);
var
  i: integer;
begin
  RecordingMode := False;
  StopButton.Enabled := False;
  StartButton.Enabled := True;
  LogTimePreset := 0;
  LogTimeCurrent := 0;
  NextRecordIn.Caption := '';
  LCLoggedCount := 0;
  RecordsLogged.Caption := IntToStr(LCLoggedCount);
  LCLogFileCount := 0;
  FilesLogged.Caption := IntToStr(LCLogFileCount);
  OldSecond := SecondOf(Now);
  RecordsMissedCount := 0;
  RecordsMissed.Caption := IntToStr(RecordsMissedCount);
  AnnotateButton.Enabled := False;


  for i := 1 to HotkeyStringGrid.RowCount - 1 do
  begin
    HotKeyCodes[i] := StrToIntDef(vConfigurations.ReadString('HotKeys',
      'h' + IntToStr(i - 1), ''), 0);
    HotkeyStringGrid.Cells[0, i] :=
      keyslist(StrToIntDef(vConfigurations.ReadString('HotKeys', 'h' +
      IntToStr(i - 1), ''), 0));
    HotkeyStringGrid.Cells[1, i] :=
      vConfigurations.ReadString('HotKeys', 'a' + IntToStr(i - 1), '');
  end;

  SynchronizedCheckBox.Checked := vConfigurations.ReadBool('HotKeys', 'sync', False);
  PersistentCheckBox.Checked := vConfigurations.ReadBool('HotKeys', 'pers', False);

  CheckSynchronized();

  if (rotstage) then
      RSGroupBox.Visible:=True;

  if SelectedModel = model_GDM then
     GDMGroupBox.Visible:=True
  else
      GDMGroupBox.Visible:=False;

  //Check if instant recording is to be done.
  if ParameterCommand('-LCR') then
     begin
      StartButtonClick(FormLogCont);
      StartUpTimer.Enabled:=True;
     end;

  //Enable appropriate axis for select model
  //if SelectedModel=model_V then begin
  //  Chart1.AxisList.Axes[2].Visible:=True;
  //  Chart1.AxisList.Axes[3].Visible:=True;
  //end
  //else begin
  //  Chart1.AxisList.Axes[2].Visible:=False;
  //  Chart1.AxisList.Axes[3].Visible:=False;
  //end;
  if SelectedModel=model_V then begin
    AltAzPlotpanel.Visible:=True;
  end
  else begin
    AltAzPlotpanel.Visible:=False;
  end;

  //Initially show the trigger tab
  PageControl1.PageIndex:=0;

  GetStartStopSettings();

end;

procedure TFormLogCont.PersistentCheckBoxChange(Sender: TObject);
begin
  if (PersistentCheckBox.Checked) then
    vConfigurations.WriteBool('HotKeys', 'pers', True)
  else
    vConfigurations.WriteBool('HotKeys', 'pers', False);
end;

procedure TFormLogCont.RadioButton1Click(Sender: TObject);
begin
  // Check all radio buttons in this group, and save value
  if RadioButton1.Checked then LCTriggerMode:=0;
  if RadioButton2.Checked then LCTriggerMode:=1;
  if RadioButton3.Checked then LCTriggerMode:=2;
  if RadioButton4.Checked then LCTriggerMode:=3;
  if RadioButton5.Checked then LCTriggerMode:=4;
  if RadioButton6.Checked then LCTriggerMode:=5;
  if RadioButton7.Checked then LCTriggerMode:=6;
  if RadioButton8.Checked then LCTriggerMode:=7;

  vConfigurations.WriteString('LogContinuousSettings', 'Mode',IntToStr(LCTriggerMode));

end;

procedure TFormLogCont.SetLocationButtonClick(Sender: TObject);
begin

  worldmap.FormWorldmap.ShowModal;

  GetStartStopSettings();

end;


procedure TFormLogCont.FineTimerTimer(Sender: TObject);
var
  ThisMoment: TDateTime;
begin
  // Only trigger out once per second with ~20ms accuracy.
  // This prevents general drift in recordings.

  FineTimer.Enabled := False;

  if (SecondOf(Now) <> OldSecond) then
  begin
    OldSecond := SecondOf(Now);
    if (RecordingMode) then
    begin
      //Gets triggered by the fine timer once per second if RecordingMode is true.

      if (Recording = False) then
        //Prevent more recording while already busy saving a record
      begin
        ThisMoment := RecodeMilliSecond(Now, 0);
        CurrentTime.Caption := FormatDateTime('yyyy-mm-dd hh:nn:ss', ThisMoment);

        // Check if counter has expired while in Seconds or Minutes mode
        case LCTriggerMode of
          0..1:
          begin // Seconds or Minutes mode selected
            Dec(LogTimeCurrent);
            if (LogTimeCurrent <= 0) then
            begin
              //LogContTimer.Enabled := False;

              // Log value//* threshold checking
              LogOneReading;

              // Restart counter for continuous logging
              LogTimeCurrent := LogTimePreset;
              NextRecordAt.Caption :=
                FormatDateTime('yyyy-mm-dd hh:nn:ss',
                IncSecond(ThisMoment, LogTimeCurrent));
              NextRecordIn.Caption := Sec2DHMS(LogTimeCurrent);

              RecordsLogged.Caption := IntToStr(LCLoggedCount);
              //LogContTimer.Enabled := True;
            end
            else
              NextRecordIn.Caption := Sec2DHMS(LogTimeCurrent);

          end;

          2..7:
          begin // On-the-clock mode selected
            if (CompareDateTime(ThisMoment, DesiredLogTime) >= 0) then
            begin
              //LogContTimer.Enabled := False;

              // Log value//* threshold checking
              LogOneReading;

              case LCTriggerMode of
                2: OnTheClock(ThisMoment, 1); //Every 1 minute
                3: OnTheClock(ThisMoment, 5); //Every 5 minutes
                4: OnTheClock(ThisMoment, 10); //Every 10 minutes
                5: OnTheClock(ThisMoment, 15); //Every 15 minutes
                6: OnTheClock(ThisMoment, 30); //Every 30 minutes
                7: OnTheClock(ThisMoment, 60); //Every hour
              end;

              RecordsLogged.Caption := IntToStr(LCLoggedCount);
              //LogContTimer.Enabled := True;
            end
            else //continue counting
            begin
              LogTimeCurrent := Round(SecondSpan(ThisMoment, DesiredLogTime));
              NextRecordIn.Caption := Sec2DHMS(LogTimeCurrent);
            end;
          end;
        end;

        if StopRecording then begin
          RecordingMode := False;
          StopButton.Enabled := False;
          StartButton.Enabled := True;
          LCTrigSeconds.Enabled := True;
          LCTrigMinutes.Enabled := True;
          LogTimePreset := 0;
          LogTimeCurrent := 0;
          NextRecordIn.Caption := '';
          AnnotateButton.Enabled := False;
          EditHotkeysCheckBox.Checked := True;
          EditHotkeysCheckBox.Enabled := False;
          HotkeyStringGrid.Enabled := True;
          HotkeyStringGrid.Font.Color := clDefault;

          if (rotstage) then begin
            RSser.SendString('E0' + chr(13) + chr(10));
            RSser.Free;
          end;

          CloseButton.Enabled := True;
          GroupBox1.Enabled := True;
        end;
      end; //End of checking Recording flag

    end;

  end;

  //Set length of timer and start it if still recording
  if not StopRecording then begin
    FineTimer.Interval := 1000 - MilliSecondOf(Now);
    FineTimer.Enabled := True;
  end;

end;


procedure TFormLogCont.StartButtonClick(Sender: TObject);  //Start recording
var
  ThisMoment: TDateTime;
  LogMinutes: integer;

begin
  StopRecording := False;

  MPSASSeries.Clear;

  if (rotstage) then begin
    //0. Connect to the ardiuno rotation stage serial port.
    //1. Center between limit switches, move to actual center offset, set position to zero
    //2. Take a reading
    //3. Step to the right
    //   goto step 2 until right limit switch is hit

    RSser := TBlockSerial.Create;
    RSser.LinuxLock := False;
    //lock file sometimes persists stuck if program closes before port
    //RSser.Connect('/dev/ttyUSB2'); //ComPort
    RSser.Connect(FormLogCont.RSComboBox.Text); //ComPort
    RSser.config(9600, 8, 'N', SB1, False, False);
    WriteLn('Device: ' + RSser.Device + '   Status: ' + RSser.LastErrorDesc +
      ' ' + IntToStr(RSser.LastError));

    //Update position display
    FormLogCont.RSStatusBar.Panels.Items[0].Text := 'Connected';
    FormLogCont.RSCurrentPositionAngleDisplay.Text := '';
    Application.ProcessMessages;

    //Turn LIGHT on
    sleep(1500);
    RSser.SendString('C4' + chr(13) + chr(10));
    ParseRotstage(Trim(RSser.Recvstring(20000)));

    //Enable motor
    sleep(1500);
    RSser.SendString('E1' + chr(13) + chr(10));
    ParseRotstage(Trim(RSser.Recvstring(20000)));

    // Center the stage
    FormLogCont.RSStatusBar.Panels.Items[0].Text := 'Finding limits';
    Application.ProcessMessages;
    RSser.SendString('C0' + chr(13) + chr(10));
    ParseRotstage(Trim(RSser.Recvstring(20000)));

    FormLogCont.RSStatusBar.Panels.Items[0].Text := 'Found limits';
    Application.ProcessMessages;
    sleep(1000);
    // Move to actual center offset
    FormLogCont.RSStatusBar.Panels.Items[0].Text := 'Applying center offset';
    Application.ProcessMessages;
    RSser.SendString('M0' + chr(13) + chr(10));
    ParseRotstage(Trim(RSser.Recvstring(20000)));
    FormLogCont.RSStatusBar.Panels.Items[0].Text := 'Mechanically centered';
    FormLogCont.RSCurrentPositionAngleDisplay.Text := '0.0';

    Application.ProcessMessages;

    sleep(1000);
    // Set position to zero
    RSser.SendString('C3' + chr(13) + chr(10));
    FormLogCont.RSStatusBar.Panels.Items[0].Text := 'Position centered';
    //Update position display
    FormLogCont.RSCurrentPositionStepDisplay.Text := '0';
    Application.ProcessMessages;

    //SendGet:=Trim(ser.Recvstring(20000));
    //Writeln(SendGet);

    //RSser.Free;

  end;

  //Grab selected time, convert to seconds, store in LogTimePreset


  //Grab current time:
  ThisMoment := RecodeMilliSecond(Now, 0); //Strip fractional seconds for display
  CurrentTime.Caption := FormatDateTime('yyyy-mm-dd hh:nn:ss', ThisMoment);

  case LCTriggerMode of
    0: //Every x seconds (on the second)
    begin
      LogTimePreset :=  LimitInteger(LCTrigSeconds.Value,1,255);
      LCTrigSeconds.Value := LogTimePreset;
      LogTimeCurrent := LogTimePreset;
      NextRecordAt.Caption := FormatDateTime('yyyy-mm-dd hh:nn:ss',
        IncSecond(ThisMoment, LogTimeCurrent));
      Setting := Format('every %d seconds', [LogTimePreset]);
    end;
    1: //Every x minutes (at 0 seconds)
    begin
      { TODO : ontheclock x minutes }
      LogMinutes :=  LimitInteger(LCTrigMinutes.Value,1,255);
      LogTimePreset := LogMinutes * 60;
      LCTrigMinutes.Text := IntToStr(LogTimePreset div 60);
      LogTimeCurrent := LogTimePreset;
      NextRecordAt.Caption := FormatDateTime('yyyy-mm-dd hh:nn:ss',
        IncSecond(ThisMoment, LogTimeCurrent));
      if LogMinutes = 1 then
        Setting := Format('every 1 minute', [LogMinutes])
      else
        Setting := Format('every %d minutes', [LogMinutes]);
    end;
    2: //Every 1 minutes
    begin
      OnTheClock(ThisMoment, 1);
      Setting := 'every 1 minute on the minute';
    end;
    3: //Every 5 minutes
    begin
      OnTheClock(ThisMoment, 5);
      Setting := 'every 5 minutes on the 1/12th hour';
    end;
    4://Every 10 minutes
    begin
      OnTheClock(ThisMoment, 10);
      Setting := 'every 10 minutes on the 1/6th hour';
    end;
    5://Every 15 minutes
    begin
      OnTheClock(ThisMoment, 15);
      Setting := 'every 15 minutes on the 1/4 hour';
    end;
    6://Every 30 minutes
    begin
      OnTheClock(ThisMoment, 30);
      Setting := 'every 30 minutes on the 1/2 hour';
    end;
    7://Every hour
    begin
      OnTheClock(ThisMoment, 60);
      Setting := 'every hour on the hour';
    end;
  end;

  NextRecordIn.Caption := Sec2DHMS(LogTimeCurrent);
  RecordingMode := True;
  Chart2LineSeries1.Clear; //Clear chart
  PageControl1.PageIndex:=1;   //show the chart tab
  StopButton.Enabled := True;
  StartButton.Enabled := False;
  CloseButton.Enabled := False;
  LCTrigSeconds.Enabled := False;
  LCTrigMinutes.Enabled := False;
  LCLoggedCount := 0;
  RecordsLogged.Caption := IntToStr(LCLoggedCount);
  GroupBox1.Enabled := False;
  RecordsViewSynMemo.Clear;
  AnnotateButton.Enabled := True;
  EditHotkeysCheckBox.Checked := False;
  EditHotkeysCheckBox.Enabled := True;
  HotkeyStringGrid.Enabled := False;
  HotkeyStringGrid.Font.Color := clInactiveCaption;
  RecordsMissed.Color := clDefault;
  RecordsMissed.Font.Color := clDefault;
  RecordsMissedCount := 0;
  RecordsMissed.Caption := IntToStr(RecordsMissedCount);
  RSCurrentStepNumber:=0;

  try
    // Open file and store header
    WriteDLHeader('LE', Format('Logged continuously %s.', [setting]));
    Flush(DLRecFile);
    CloseFile(DLRecFile);
    LCLogFileCount := 1;
    FilesLogged.Caption := IntToStr(LCLogFileCount);
    Labelfile.Caption := 'file';

    //Save initial log time for 24 rollover check later
    LCStartFileTime := ThisMoment;

    LogOneReading; //First reading

  except
    StatusMessage('ERROR! IORESULT: ' + IntToStr(IOResult)+ ' during StartButtonClick');
  end;

  //Set length of timer and start it
  FineTimer.Interval := 1000 - MilliSecondOf(Now);
  FineTimer.Enabled := True;

end;

procedure TFormLogCont.StartUpTimerTimer(Sender: TObject);
begin
  //Check if window should be minimized automatically when instant recording is desired
  if ParameterCommand('-LCMIN') then
     begin
        Application.Minimize;
        Application.ProcessMessages;
     end;
  StartUpTimer.Enabled:=False;
end;

procedure TFormLogCont.StopButtonClick(Sender: TObject);
begin
  StopRecording := True;
end;

procedure TFormLogCont.HotkeyStringGridKeyUp(Sender: TObject;
  var Key: word; Shift: TShiftState);
var
  i: integer;

  function StrippedOfNonAscii(const s: string): string;
  var
    i, Count: integer;
  begin
    SetLength(Result, Length(s));
    Count := 0;
    for i := 1 to Length(s) do
    begin
      if ((s[i] >= #32) and (s[i] < #127)) or (s[i] in [#10, #13]) then
      begin
        Inc(Count);
        Result[Count] := s[i];
      end;
    end;
    SetLength(Result, Count);
  end;

begin
  if HotkeyStringGrid.Col = 0 then
  begin
    HotkeyStringGrid.Cells[HotkeyStringGrid.Col, HotkeyStringGrid.Row] := keyslist(Key);
    HotKeyCodes[HotkeyStringGrid.Row] := Key;
  end;

  for i := 1 to HotkeyStringGrid.RowCount - 1 do
  begin
    vConfigurations.WriteString('HotKeys', 'h' + IntToStr(i - 1),
      IntToStr(HotKeyCodes[i]));
    vConfigurations.WriteString('HotKeys', 'a' + IntToStr(i - 1),
      StrippedOfNonAscii(HotkeyStringGrid.Cells[1, i]));
  end;
end;

procedure TFormLogCont.HotkeyStringGridSelectEditor(Sender: TObject;
  aCol, aRow: integer; var Editor: TWinControl);
begin
  if Editor is TStringCellEditor then
    CustomizeEdit(aCol, aRow, Editor as TStringCellEditor);
end;

procedure TFormLogCont.CheckSynchronized();
begin
  if (SynchronizedCheckBox.Checked) then
  begin
    PendingHotKey.Enabled := True;
    PendingLabel.Enabled := True;
    vConfigurations.WriteBool('HotKeys', 'sync', True);
  end
  else
  begin
    PendingHotKey.Enabled := False;
    PendingLabel.Enabled := False;
    vConfigurations.WriteBool('HotKeys', 'sync', False);
  end;
end;

procedure TFormLogCont.SynchronizedCheckBoxChange(Sender: TObject);
begin
  CheckSynchronized();
end;

procedure TFormLogCont.CustomizeEdit(ACol, ARow: integer; Editor: TStringCellEditor);
begin
  if aCol = 1 then
    Editor.MaxLength := 0;

end;

initialization
  {$I logcont.lrs}

end.
